diff --git a/gdb/corefile.c b/gdb/corefile.c
index 5cb559000b82..1fbefd2eb8f9 100644
--- a/gdb/corefile.c
+++ b/gdb/corefile.c
@@ -33,6 +33,7 @@
 #include "observable.h"
 #include "cli/cli-utils.h"
 #include "gdbarch.h"
+#include "interps.h"
 
 /* You can have any number of hooks for `exec_file_command' command to
    call.  If there's only one hook, it is set in exec_file_display
@@ -353,6 +354,16 @@ write_memory (CORE_ADDR memaddr,
     memory_error (TARGET_XFER_E_IO, memaddr);
 }
 
+/* Notify interpreters and observers that INF's memory was changed.  */
+
+static void
+notify_memory_changed (inferior *inf, CORE_ADDR addr, ssize_t len,
+		       const bfd_byte *data)
+{
+  interps_notify_memory_changed (inf, addr, len, data);
+  gdb::observers::memory_changed.notify (inf, addr, len, data);
+}
+
 /* Same as write_memory, but notify 'memory_changed' observers.  */
 
 void
@@ -360,7 +371,7 @@ write_memory_with_notification (CORE_ADDR memaddr, const bfd_byte *myaddr,
 				ssize_t len)
 {
   write_memory (memaddr, myaddr, len);
-  gdb::observers::memory_changed.notify (current_inferior (), memaddr, len, myaddr);
+  notify_memory_changed (current_inferior (), memaddr, len, myaddr);
 }
 
 /* Store VALUE at ADDR in the inferior as a LEN-byte unsigned
diff --git a/gdb/interps.c b/gdb/interps.c
index 3cb89b113a3b..f665e86b65c7 100644
--- a/gdb/interps.c
+++ b/gdb/interps.c
@@ -591,6 +591,15 @@ interps_notify_param_changed (const char *param, const char *value)
   interps_notify (&interp::on_param_changed, param, value);
 }
 
+/* See interps.h.  */
+
+void
+interps_notify_memory_changed (inferior *inf, CORE_ADDR addr, ssize_t len,
+			       const bfd_byte *data)
+{
+  interps_notify (&interp::on_memory_changed, inf, addr, len, data);
+}
+
 /* This just adds the "interpreter-exec" command.  */
 void _initialize_interpreter ();
 void
diff --git a/gdb/interps.h b/gdb/interps.h
index 948b6f520df0..ebe078eb7394 100644
--- a/gdb/interps.h
+++ b/gdb/interps.h
@@ -178,6 +178,10 @@ class interp : public intrusive_list_node<interp>
   /* Notify the interpreter that parameter PARAM changed to VALUE.  */
   virtual void on_param_changed (const char *param, const char *value) {}
 
+  /* Notify the interpreter that inferior INF's memory was changed.  */
+  virtual void on_memory_changed (inferior *inf, CORE_ADDR addr, ssize_t len,
+				  const bfd_byte *data) {}
+
 private:
   /* The memory for this is static, it comes from literal strings (e.g. "cli").  */
   const char *m_name;
@@ -359,6 +363,10 @@ extern void interps_notify_breakpoint_modified (breakpoint *b);
 /* Notify all interpreters that parameter PARAM changed to VALUE.  */
 extern void interps_notify_param_changed (const char *param, const char *value);
 
+/* Notify all interpreters that inferior INF's memory was changed.  */
+extern void interps_notify_memory_changed (inferior *inf, CORE_ADDR addr,
+					   ssize_t len, const bfd_byte *data);
+
 /* well-known interpreters */
 #define INTERP_CONSOLE		"console"
 #define INTERP_MI2             "mi2"
diff --git a/gdb/mi/mi-interp.c b/gdb/mi/mi-interp.c
index c6e70a779648..473490be8ff5 100644
--- a/gdb/mi/mi-interp.c
+++ b/gdb/mi/mi-interp.c
@@ -60,9 +60,6 @@ static int mi_interp_query_hook (const char *ctlstr, va_list ap)
 static void mi_insert_notify_hooks (void);
 static void mi_remove_notify_hooks (void);
 
-static void mi_memory_changed (struct inferior *inf, CORE_ADDR memaddr,
-			       ssize_t len, const bfd_byte *myaddr);
-
 /* Display the MI prompt.  */
 
 static void
@@ -812,50 +809,39 @@ mi_interp::on_param_changed (const char *param, const char *value)
   gdb_flush (this->event_channel);
 }
 
-/* Emit notification about the target memory change.  */
-
-static void
-mi_memory_changed (struct inferior *inferior, CORE_ADDR memaddr,
-		   ssize_t len, const bfd_byte *myaddr)
+void
+mi_interp::on_memory_changed (inferior *inferior, CORE_ADDR memaddr,
+			      ssize_t len, const bfd_byte *myaddr)
 {
   if (mi_suppress_notification.memory)
     return;
 
-  SWITCH_THRU_ALL_UIS ()
-    {
-      struct mi_interp *mi = as_mi_interp (top_level_interpreter ());
-      struct ui_out *mi_uiout;
-      struct obj_section *sec;
-
-      if (mi == NULL)
-	continue;
-
-      mi_uiout = top_level_interpreter ()->interp_ui_out ();
 
-      target_terminal::scoped_restore_terminal_state term_state;
-      target_terminal::ours_for_output ();
+  ui_out *mi_uiout = this->interp_ui_out ();
 
-      gdb_printf (mi->event_channel, "memory-changed");
+  target_terminal::scoped_restore_terminal_state term_state;
+  target_terminal::ours_for_output ();
 
-      ui_out_redirect_pop redir (mi_uiout, mi->event_channel);
+  gdb_printf (this->event_channel, "memory-changed");
 
-      mi_uiout->field_fmt ("thread-group", "i%d", inferior->num);
-      mi_uiout->field_core_addr ("addr", target_gdbarch (), memaddr);
-      mi_uiout->field_string ("len", hex_string (len));
+  ui_out_redirect_pop redir (mi_uiout, this->event_channel);
 
-      /* Append 'type=code' into notification if MEMADDR falls in the range of
-	 sections contain code.  */
-      sec = find_pc_section (memaddr);
-      if (sec != NULL && sec->objfile != NULL)
-	{
-	  flagword flags = bfd_section_flags (sec->the_bfd_section);
+  mi_uiout->field_fmt ("thread-group", "i%d", inferior->num);
+  mi_uiout->field_core_addr ("addr", target_gdbarch (), memaddr);
+  mi_uiout->field_string ("len", hex_string (len));
 
-	  if (flags & SEC_CODE)
-	    mi_uiout->field_string ("type", "code");
-	}
+  /* Append 'type=code' into notification if MEMADDR falls in the range of
+     sections contain code.  */
+  obj_section *sec = find_pc_section (memaddr);
+  if (sec != nullptr && sec->objfile != nullptr)
+    {
+      flagword flags = bfd_section_flags (sec->the_bfd_section);
 
-      gdb_flush (mi->event_channel);
+      if (flags & SEC_CODE)
+	mi_uiout->field_string ("type", "code");
     }
+
+  gdb_flush (this->event_channel);
 }
 
 void
@@ -959,6 +945,4 @@ _initialize_mi_interp ()
   interp_factory_register (INTERP_MI3, mi_interp_factory);
   interp_factory_register (INTERP_MI4, mi_interp_factory);
   interp_factory_register (INTERP_MI, mi_interp_factory);
-
-  gdb::observers::memory_changed.attach (mi_memory_changed, "mi-interp");
 }
diff --git a/gdb/mi/mi-interp.h b/gdb/mi/mi-interp.h
index 51f22b2ef112..8540e3fa4fc8 100644
--- a/gdb/mi/mi-interp.h
+++ b/gdb/mi/mi-interp.h
@@ -70,6 +70,8 @@ class mi_interp final : public interp
   void on_breakpoint_deleted (breakpoint *b) override;
   void on_breakpoint_modified (breakpoint *b) override;
   void on_param_changed (const char *param, const char *value) override;
+  void on_memory_changed (inferior *inf, CORE_ADDR addr, ssize_t len,
+			  const bfd_byte *data) override;
 
   /* MI's output channels */
   mi_console_file *out;